`timescale 1ns / 1ps
//////////////////////////////////////////////////////////////////////////////////
// Company: 
// Engineer: 
// 
// Create Date:    16:20:19 05/17/2019 
// Design Name: 
// Module Name:    square_root_NR 
// Project Name: 
// Target Devices: 
// Tool versions: 
// Description: 
//
// Dependencies: 
//
// Revision: 
// Revision 0.01 - File Created
// Additional Comments: 
//
//////////////////////////////////////////////////////////////////////////////////
module square_root_Res(x,q,r);

input [7:0] x;
output [4:0] r;
output [3:0] q;

wire co,co1,co2,co3,co4,co5,co6,co7,co8,co9;

wire t1,t2,t3,t4,t5,t6,t7,t8,t9,t10;
wire q1,q2,q3,q4;

CAS1 m1(1'b0,x[7],co,q1,t2,q1);
CAS1 m2(1'b1,x[6],1'b0,q1,t1,co);

CAS1 m3(1'b0,t2,co3,q2,t6,q2);
CAS1 m4(~q1,t1,co2,q2,t5,co3);
CAS1 m5(1'b0,x[5],co1,q2,t4,co2);
CAS1 m6(1'b1,x[4],1'b0,q2,t3,co1);

CAS1 m7(1'b0,t5,co7,q3,t11,q3);
CAS1 m8(~q1,t4,co6,q3,t10,co7);
CAS1 m9(~q2,t3,co5,q3,t9,co6);
CAS1 m10(1'b0,x[3],co4,q3,t8,co5);
CAS1 m11(1'b1,x[2],1'b0,q3,t7,co4);

CAS1 m12(1'b0,t10,co12,q2,t17,q4);
CAS1 m13(~q1,t9,co11,q4,t16,co12);
CAS1 m14(~q2,t8,co10,q4,t15,co11);
CAS1 m15(~q3,t7,co9,q4,t14,co10);
CAS1 m16(1'b0,x[1],co8,q4,t13,co9);
CAS1 m17(1'b1,x[0],1'b0,q4,t12,co8);

assign q = {~q1,~q2,~q3,~q4};
assign r = {t16,t15,t14,t13,t12};
endmodule
